import javax.script.Compilable;
import javax.script.CompiledScript;
import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;

public class CompilableDemo {

    public static void main(String[] args) {

        // create ScriptEngineManager
        ScriptEngineManager manager = new ScriptEngineManager();

        // create ScriptEngine for JavaScript (js) 
        ScriptEngine engine = manager.getEngineByName("js");

        Compilable jsCompile = (Compilable) engine;
        try {
            CompiledScript script = jsCompile.compile(
                    "function hi() {print('Hello !'); }; hi();");

            for (int i = 0; i < 5; i++) {
                script.eval();
            }    
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}

